//
//  PokemonsViewController.swift
//  Demo de las Slides
//
//  Created by Santiago Pavón on 3/12/14.
//  Copyright (c) 2014 UPM. All rights reserved.
//

import UIKit

let reuseIdentifier = "Pokemon Cell"

class PokemonsViewController: UICollectionViewController {

    private var pokedexModel = PokedexModel()
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Register cell classes
        //  self.collectionView.registerClass(UICollectionViewCell.self,
        //                      forCellWithReuseIdentifier: reuseIdentifier)

        // Do any additional setup after loading the view.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    
    
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        
        if segue.identifier == "Show Web Info" {
            
            if let ip = collectionView?.indexPathForCell(sender as PokemonCell) {
                
                if let wvc = segue.destinationViewController as? WebViewController {
                    
                    let type = pokedexModel.types[ip.section]
                    let race = type.races[ip.item]
                    
                    wvc.race = race
                }
            }
        }
    }

    
    
    // MARK: UICollectionViewDataSource

    override func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
        return pokedexModel.types.count
    }

    override func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return pokedexModel.types[section].races.count
    }

    override func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCellWithReuseIdentifier(
                            reuseIdentifier, forIndexPath: indexPath) as PokemonCell
    
        let type = pokedexModel.types[indexPath.section]
        let race = type.races[indexPath.item]
        
        cell.nameLabel.text = race.name
        cell.iconImageView.image = UIImage(named: race.icon)
        
        return cell
    }

    
    
    override func collectionView(collectionView: UICollectionView,
        viewForSupplementaryElementOfKind kind: String,
        atIndexPath indexPath: NSIndexPath) -> UICollectionReusableView {
            
            var cell: UICollectionReusableView! = nil
            if kind == UICollectionElementKindSectionHeader {
                
                cell = collectionView.dequeueReusableSupplementaryViewOfKind(kind, withReuseIdentifier: "Type Header", forIndexPath: indexPath) as PokemonHeader
                
                let type = pokedexModel.types[indexPath.section]
                
                (cell as PokemonHeader).nameLabel.text = type.name
                (cell as PokemonHeader).infoLabel.text = "\(type.races.count) razas"
            }
            return cell
    }
    
    
    
    // MARK: UICollectionViewDelegate

    /*
    // Uncomment this method to specify if the specified item should be highlighted during tracking
    override func collectionView(collectionView: UICollectionView, shouldHighlightItemAtIndexPath indexPath: NSIndexPath) -> Bool {
        return true
    }
    */

    /*
    // Uncomment this method to specify if the specified item should be selected
    override func collectionView(collectionView: UICollectionView, shouldSelectItemAtIndexPath indexPath: NSIndexPath) -> Bool {
        return true
    }
    */

    /*
    // Uncomment these methods to specify if an action menu should be displayed for the specified item, and react to actions performed on the item
    override func collectionView(collectionView: UICollectionView, shouldShowMenuForItemAtIndexPath indexPath: NSIndexPath) -> Bool {
        return false
    }

    override func collectionView(collectionView: UICollectionView, canPerformAction action: Selector, forItemAtIndexPath indexPath: NSIndexPath, withSender sender: AnyObject?) -> Bool {
        return false
    }

    override func collectionView(collectionView: UICollectionView, performAction action: Selector, forItemAtIndexPath indexPath: NSIndexPath, withSender sender: AnyObject?) {
    
    }
    */

}
